from thrift.transport import TSocket
from thrift.transport import TTransport
from thrift.protocol import TBinaryProtocol
from hbase import Hbase
from hbase.ttypes import *

NAME_MAP = {'train': 'cnews.train.txt',
            'val': 'cnews.val.txt',
            'test': 'cnews.test.txt'}


class HbaseClient(object):
    def __init__(self, host='10.240.212.147', port=32845):

        self.transport = TTransport.TBufferedTransport(TSocket.TSocket(host, port))

        protocol = TBinaryProtocol.TBinaryProtocol(self.transport)
        self.client = Hbase.Client(protocol)


    def get_tables(self):
        self.transport.open()
        tables = self.client.getTableNames()
        self.transport.close()
        return tables

    def get_value(self, table_name, row): 
        scope = 100
        result = {}
        self.transport.open()
        for column, filename in NAME_MAP.items():
            for s in range(scope):
                newcolumn = '{0}-{1}'.format(column, s)
                value = self.client.get(table_name, row, 'cf1:{0}'.format(newcolumn))
                if not value:
                    break
                old_value = result.get(filename, '')
                if not old_value:
                    result[filename] = value[0].value
                else:
                    result[filename] += value[0].value

        self.transport.close()
        return result

